#include <LPC177x_8x.h>
#include "EMC.h"

void EMC_User_Init(void)
{
	volatile uint32_t i;

	LPC_IOCON->P2_14 = 0x21;		   //  ncs2

	LPC_IOCON->P2_16 = 0x21;
	LPC_IOCON->P2_17 = 0x21;
	LPC_IOCON->P2_18 = 0x21;
	LPC_IOCON->P2_20 = 0x21;
	LPC_IOCON->P2_24 = 0x21;
	LPC_IOCON->P2_28 = 0x21;
	LPC_IOCON->P2_29 = 0x21;
	LPC_IOCON->P2_30 = 0x21;
	LPC_IOCON->P2_31 = 0x21;
	
    LPC_IOCON->P3_0 = 0x21;	  //D0
    LPC_IOCON->P3_1 = 0x21;
    LPC_IOCON->P3_2 = 0x21;
    LPC_IOCON->P3_3 = 0x21;
    LPC_IOCON->P3_4 = 0x21;
    LPC_IOCON->P3_5 = 0x21;
    LPC_IOCON->P3_6 = 0x21;
    LPC_IOCON->P3_7 = 0x21;
    LPC_IOCON->P3_8 = 0x21;
    LPC_IOCON->P3_9 = 0x21;
    LPC_IOCON->P3_10 = 0x21;
    LPC_IOCON->P3_11 = 0x21;
    LPC_IOCON->P3_12 = 0x21;
    LPC_IOCON->P3_13 = 0x21;
    LPC_IOCON->P3_14 = 0x21;
    LPC_IOCON->P3_15 = 0x21;  //D15
    LPC_IOCON->P4_0 = 0x21;	  //a0
    LPC_IOCON->P4_1 = 0x21;
    LPC_IOCON->P4_2 = 0x21;
    LPC_IOCON->P4_3 = 0x21;
    LPC_IOCON->P4_4 = 0x21;
    LPC_IOCON->P4_5 = 0x21;
    LPC_IOCON->P4_6 = 0x21;
    LPC_IOCON->P4_7 = 0x21;
    LPC_IOCON->P4_8 = 0x21;
    LPC_IOCON->P4_9 = 0x21;
    LPC_IOCON->P4_10 = 0x21;
    LPC_IOCON->P4_11 = 0x21;
    LPC_IOCON->P4_12 = 0x21;
    LPC_IOCON->P4_13 = 0x21;
    LPC_IOCON->P4_14 = 0x21;  //a14
    LPC_IOCON->P4_15 = 0x21;  //a15
    LPC_IOCON->P4_16 = 0x21;  //a16
    LPC_IOCON->P4_17 = 0x21;  //a17
    LPC_IOCON->P4_18 = 0x21;  //a18
    LPC_IOCON->P4_19 = 0x21;  //a19
    LPC_IOCON->P4_20 = 0x21;  //a20
    
    LPC_IOCON->P4_24 = 0x21;  //nOE
    LPC_IOCON->P4_25 = 0x21;  //nWE
    LPC_IOCON->P4_31 = 0x21;  //nCS1

    LPC_SC->PCONP   	|= (1<<11);
	LPC_SC->EMCDLYCTL   = 0x00101010;
 

LPC_EMC->Control =1;


	LPC_EMC->DynamicReadConfig = 1;
	LPC_EMC->DynamicRasCas0 = 0x00000303;
	LPC_EMC->DynamicRP = 0x00000002;//P2C(SDRAM_TRP);
	LPC_EMC->DynamicRAS = 0x00000005;//P2C(SDRAM_TRAS);
	LPC_EMC->DynamicSREX = 0x00000009;//P2C(SDRAM_TXSR);
	LPC_EMC->DynamicAPR = 0x00000001;//SDRAM_TAPR;
	LPC_EMC->DynamicDAL = 0x00000005;//SDRAM_TDAL+P2C(SDRAM_TRP);
	LPC_EMC->DynamicWR = 0x00000002;//SDRAM_TWR;
	LPC_EMC->DynamicRC = 0x00000007;//P2C(SDRAM_TRC);
	LPC_EMC->DynamicRFC = 0x00000008;//P2C(SDRAM_TRFC);
	LPC_EMC->DynamicXSR = 0x00000009;//P2C(SDRAM_TXSR);
	LPC_EMC->DynamicRRD = 0x00000001;//P2C(SDRAM_TRRD);
	LPC_EMC->DynamicMRD = 0x00000003;//SDRAM_TMRD;

	LPC_EMC->DynamicConfig0 = 0x0000680;

	LPC_EMC->DynamicControl = 0x0183;
	for(i= 200*30; i;i--);
	LPC_EMC->DynamicControl = 0x0103;
	LPC_EMC->DynamicRefresh = 2;
	for(i= 256; i; --i); // > 128 clk
	LPC_EMC->DynamicRefresh = 0x0000003A;//P2C(SDRAM_REFRESH) >> 4;

  LPC_EMC->DynamicControl    = 0x00000083; 
	i = *((volatile uint32_t *)(0xA0000000 | (0x33<<12)));
	LPC_EMC->DynamicControl = 0x0000;
	LPC_EMC->DynamicConfig0 |=(1<<19);
	
		LPC_EMC->StaticConfig1   = 0x00000081;  
  LPC_EMC->StaticWaitWen1  = 0x01;
  LPC_EMC->StaticWaitOen1  = 0x01;
	LPC_EMC->StaticWaitRd1   = 0x1f;
	LPC_EMC->StaticWaitPage1 = 0x1f;
	LPC_EMC->StaticWaitWr1   = 0x1f;
	LPC_EMC->StaticWaitTurn1 = 0x0f;
	
}
